﻿using System;
using System.Globalization;
using System.Windows.Data;

namespace TestProject
{
    /// <summary>
    /// 실수↔10진수 값 변환자
    /// </summary>
    [ValueConversion(typeof(double), typeof(decimal))]
    public class DoubleToDecimalValueConverter : IValueConverter
    {
        //////////////////////////////////////////////////////////////////////////////////////////////////// Method
        ////////////////////////////////////////////////////////////////////////////////////////// Public

        #region 변환하기 - Convert(sourceValue, targetType, parameter, cultureInfo)

        /// <summary>
        /// 변환하기
        /// </summary>
        /// <param name="sourceValue">값</param>
        /// <param name="targetType">타겟 타입</param>
        /// <param name="parameter">파라미터</param>
        /// <param name="cultureInfo">CultureInfo</param>
        /// <returns>변환 값</returns>
        public object Convert(object sourceValue, Type targetType, object parameter, CultureInfo cultureInfo)
        {
            decimal targetValue = new decimal((double)sourceValue);

            if(parameter != null)
            {
                targetValue = decimal.Round(targetValue, int.Parse(parameter as string));
            }

            return targetValue;
        }

        #endregion
        #region 역변환하기 - ConvertBack(sourceValue, targetType, parameter, cultureInfo)

        /// <summary>
        /// 역변환하기
        /// </summary>
        /// <param name="sourceValue">소스 값</param>
        /// <param name="targetType">타겟 타입</param>
        /// <param name="parameter">파라미터</param>
        /// <param name="cultureInfo">CultureInfo</param>
        /// <returns>역변환 값</returns>
        public object ConvertBack(object sourceValue, Type targetType, object parameter, CultureInfo cultureInfo)
        {
            return decimal.ToDouble((decimal)sourceValue);
        }

        #endregion
    }
}